#ifndef RES_APP_H
#define RES_APP_H

#include <Archivable.h>

// marcro de racourcis
#define get_string(entry) ResApplication::find_string(entry)
#define get_string_idx(entry,i) ResApplication::find_string(entry,i)
#define fres_app	ResApplication::res_app()

class ResApplication : public BApplication {
public:
	ResApplication(uint32 signature);
	ResApplication(const char *signature);
	ResApplication(BMessage *data);
	~ResApplication();
	static	ResApplication	*Instantiate(BMessage *data);
	static  ResApplication* res_app();
virtual	BArchivable*	LoadArchive(type_code type, int32 id);
virtual status_t		StoreArchive(type_code type, int32 id, BArchivable* obj, bool deep= true, const char* resname = NULL);
virtual status_t		FindMessage(type_code type, int32 id, BMessage* inmsg);
virtual status_t		AddMessage(type_code type, int32 id, BMessage* msg, const char* resname = NULL);
virtual BResources*		OpenResources();
virtual void			CloseResources();
virtual BResources*		Resources(bool load_if_needed = true);

		status_t		LoadStrings(type_code type, int32 id, int32 defid = 0);	// prend defid si ne trouve pas res avec id
		status_t		FindString(const char* entry_name, char** putin);
		status_t		FindString(const char* entry_name, long i, char** putin);
		
static	const char*		find_string(const char* entry_name);
static  const char*		find_string(const char* entry_name, long i);

private:
	BFile*		fich;
	BResources* res;
	
	BMessage	string_msg;
//	int32	open_count;
};

#endif